#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Odds2_VIP.h"
std::auto_ptr<Odds2_VIP> Odds2_VIP::msSingleton(nullptr);

int Odds2_VIP::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_VIPData* Odds2_VIP::GetData(int VIPlvl)
{
	auto it = mMapData.find(VIPlvl);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Odds2_VIPData>& Odds2_VIP::GetMapData()
{
	return mMapData;
}

void Odds2_VIP::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Odds2_VIP.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_VIPData data;
		data.mVIPlvl = element->IntAttribute("VIPlvl");
		data.mExpectedProfit = element->IntAttribute("ExpectedProfit");
		data.mBuffID = element->IntAttribute("BuffID");
		data.mDragonValue = element->IntAttribute("DragonValue");
		if (mMapData.find(data.mVIPlvl) != mMapData.end())std::cout <<"data refind:" << data.mVIPlvl << std::endl;
		CCASSERT(mMapData.find(data.mVIPlvl) == mMapData.end(), "data.mVIPlvl is exists");
		mMapData.insert(std::make_pair(data.mVIPlvl, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Odds2_VIP Loaded. Load Data:%u", mMapData.size());
}

void Odds2_VIP::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Odds2_VIP");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Odds2_VIP");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Odds2_VIPData data;
		LuaCfgHelper::readInt(L, "VIPlvl", data.mVIPlvl);
		LuaCfgHelper::readInt(L, "ExpectedProfit", data.mExpectedProfit);
		LuaCfgHelper::readInt(L, "BuffID", data.mBuffID);
		LuaCfgHelper::readInt(L, "DragonValue", data.mDragonValue);
		if (mMapData.find(data.mVIPlvl) != mMapData.end())std::cout <<"data refind:" << data.mVIPlvl << std::endl;
		CCASSERT(mMapData.find(data.mVIPlvl) == mMapData.end(), "data.mVIPlvl is exists");
		mMapData.insert(std::make_pair(data.mVIPlvl, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Odds2_VIP Loaded. Load Data:%u", mMapData.size());
}

void Odds2_VIP::Reload()
{
	mMapData.clear();
	Load();
}

Odds2_VIP* Odds2_VIP::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_VIP());
	}
	return msSingleton.get();
}

void Odds2_VIP::Release()
{
	msSingleton.reset(nullptr);
}
